image:
  name: trailofbits/eth-security-toolbox
  entrypoint: [""]

include: 
  - project: "projecttxa/txa-utils/txa-ci-templates"
    file: "/templates/gpg-validate.yml"
  - project: "projecttxa/txa-utils/txa-ci-templates"
    file: "/templates/docker.yml"

variables:
    IMAGE_TAG: "$CI_REGISTRY_IMAGE/txa-settlement-contracts-cliquebait:latest"
    GPG_FILE: "settlements.csv"
    DOCKER_TLS_CERTDIR: "/certs"

.before_script:
  before_script:
    - npm ci
    # below is necessary to prevent `fatal: unsafe repository`
    - git config --global --add safe.directory /builds/projecttxa/txa-dsl/txa-settlement-contracts

stages:
  - validate
  - test
  - test-build
  - publish

gpg_validate:
  stage: validate
  extends:
    - .gpg-validate

unit-tests:
  extends: .before_script
  stage: test
  tags: [docker]
  only:
    - merge_requests
  except:
    - develop@projecttxa/txa-dsl/txa-settlement-contracts
    - master@projecttxa/txa-dsl/txa-settlement-contracts
  script:
    - npx hardhat compile
    - npx hardhat test test/unit-tests/**.ts
    - npx hardhat test test/tasks.ts

unit-tests-upstream:
  extends: .before_script
  stage: test
  tags: [docker]
  only:
    - develop@projecttxa/txa-dsl/txa-settlement-contracts
    - master@projecttxa/txa-dsl/txa-settlement-contracts
  script:
    - npx hardhat compile
    - npx hardhat test test/unit-tests/**.ts
    - npx hardhat test test/tasks.ts

test-build:
  stage: test-build
  needs: [unit-tests]
  except:
    - develop@projecttxa/txa-dsl/txa-settlement-contracts
    - master@projecttxa/txa-dsl/txa-settlement-contracts
  only:
    - merge_requests
  extends:
    - .docker-base
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .

publish:
  stage: publish
  extends:
    - .docker-build
  rules:
    - if: '$CI_COMMIT_BRANCH == "0.8"'
    - if: "$CI_COMMIT_MESSAGE =~ /^Merge branch .+/"
